<?php
/**
 * Quantum Gateway Web Form eShop Payment module - Main script
 * 
 * @version 0.0.3
 * @author mthosting <support@mthosting.net>
 * @license http://opensource.org/licenses/GPL-3.0 GNU General Public License, version 3 (GPL-3.0)
 * @copyright Copyright (c) 2012 MT Hosting.
 * 
 * Below are settings required for Wordpress
 * 
 * Plugin Name: Quantum Gateway Web Form for eShop
 * Plugin URI: http://wordpress.org/extend/plugins/eshop-quantumwebform/
 * Description: Enables Quantum Gateway Web Form within eShop
 * Author: mthosting
 * Version: 0.0.3
 * Author URI: http://www.mthosting.net
 */
 
if ('quantumwebform.php' == basename($_SERVER['SCRIPT_FILENAME']))
 	die ('<h2>Direct File Access Prohibited</h2>');
 
register_activation_hook(__FILE__,'eshopquantum_activate');
function eshopquantum_activate(){
    /*
    * Activation routines
    */
    global $wpdb;
    $opts=get_option('active_plugins');
    $eshopthere=false;
    foreach($opts as $opt)
	{
		if($opt=='eshop/eshop.php')
			$eshopthere=true;
    }
    if($eshopthere==false){
        deactivate_plugins('quantumwebform.php'); //Deactivate ourself
        wp_die(__('ERROR! eShop is not active.','eshop'));
    }
}

add_action('eshop_setting_merchant_load','eshopquantumqpage');

function eshopquantumqpage($thist){
    /*
    * adding the meta box for this gateway
    */
    add_meta_box('eshop-m-quantumpage', __('Quantum Gateway Checkout','eshop'), 'quantumgateway_box', $thist->pagehook, 'normal', 'core');
}

function quantumgateway_box($eshopoptions) {
    /*
    * the meta box content, obviously you have to set up the required fields for your gateway here
    */
	//var_dump($eshopoptions);
    if(isset($eshopoptions['quantumwf']))
	{
        $eshopquantumwf = $eshopoptions['quantumwf'];
    }
	else
	{
        $eshopquantumwf['email']='';
        $eshopquantumwf['merchant_id']='';
        $eshopquantumwf['api_key']='';
    }
	
	echo '<fieldset>';?>
    <p class="cbox">
        <input id="eshop_methodquantumwf" name="eshop_method[]" type="checkbox" value="quantumwf"<?php if(in_array('quantumwf',(array)$eshopoptions['method'])) echo ' checked="checked"'; ?> />
        <label for="eshop_methodquantumwf" class="eshopmethod">
            <?php _e('Accept payment by Quantum Gateway Webform Checkout','eshop'); ?>
        </label>
    </p>
    <label for="eshop_quantumwfgwlogin"><?php _e('Gateway Login Username','eshop'); ?></label>
    	<input id="eshop_quantumwfgwlogin" name="quantumwf[gwlogin]" type="text" value="<?php echo $eshopquantumwf['gwlogin']; ?>" size="30" maxlength="50" /><br />
    <label for="eshop_quantumwfmd5"><?php _e('MD5 Hash from Quantum Gateway Site','eshop'); ?></label>
    <input id="eshop_quantumwfmd5" name="quantumwf[md5]" type="text" value="<?php echo $eshopquantumwf['md5']; ?>" size="30" maxlength="50" /><br />
	<label for="eshop_quantumwflogoURL"><?php _e('Logo URL to include on checkout page over SSL if possible','eshop'); ?></label>
    	<input id="eshop_quantumwflogoURL" name="quantumwf[logoURL]" type="text" value="<?php echo $eshopquantumwf['logoURL']; ?>" size="30" maxlength="150" /><br />
     <label for="eshop_quantumwfTitle"><?php _e('Checkout page title','eshop'); ?></label>
    	<input id="eshop_quantumwfTitle" name="quantumwf[Title]" type="text" value="<?php echo $eshopquantumwf['Title']; ?>" size="30" maxlength="150" /><br />
    <label for="eshop_quantumwfHeader"><?php _e('Text of header of checkout page','eshop'); ?></label>
    	<input id="eshop_quantumwfHeader" name="quantumwf[Header]" type="text" value="<?php echo $eshopquantumwf['Header']; ?>" size="30" maxlength="150" /><br />
    
    </fieldset>
<?php
}

add_filter('eshop_setting_merchant_save','quantumwfsave',10,2);
function quantumwfsave($eshopoptions,$posted)
{
    /*
    * save routine for the fields you added above
    */
	//var_dump($eshopoptions);
    global $wpdb;
    $quantumwfpost['gwlogin']=$wpdb->escape($posted['quantumwf']['gwlogin']);
    $quantumwfpost['logoURL']=$wpdb->escape($posted['quantumwf']['logoURL']);
	$quantumwfpost['Title']=$wpdb->escape($posted['quantumwf']['Title']);
	$quantumwfpost['Header']=$wpdb->escape($posted['quantumwf']['Header']);
	$quantumwfpost['md5']=$wpdb->escape($posted['quantumwf']['md5']);

    $eshopoptions['quantumwf']=$quantumwfpost;
    return $eshopoptions;
}

add_filter('eshop_merchant_img_quantumwf','quantumwfimg');
function quantumwfimg($array){
    /*
    * adding the image for this gateway, for use on the front end of the site
    */
    $array['path']=WP_PLUGIN_DIR.'/eshop-quantumwebform/images/button.png';
    $array['url']=WP_PLUGIN_URL.'/eshop-quantumwebform/images/button.png';
    return $array;
}

add_filter('eshop_mg_inc_path','quantumwfpath',10,2);
function quantumwfpath($path,$paymentmethod){
    /*
    * adding another necessary link for the instant payment notification of your gateway
    */
    if($paymentmethod=='quantumwf')
            return WP_PLUGIN_DIR.'/eshop-quantumwebform/quantumwebform.checkout.php';
    return $path;
}

add_filter('eshop_show_success', 'eshop_quantumwf_return_fail',10,3);
function eshop_quantumwf_return_fail($echo, $eshopaction, $postit){
	global $wpdb, $eshopoptions;
	$detailstable=$wpdb->prefix.'eshop_orders';
	
	//check md5 hash
	if($eshopoptions["quantumwf"]["md5"])
	{
		//make sure we have a hash
		if(md5($eshopoptions["quantumwf"]["md5"].$eshopoptions["quantumwf"]["gwlogin"].$postit["transID"].$postit["amount"]) != $postit["md5_hash"])
		{
			$postit['transID'] .= '| MD5 Failed';
			$postit['trans_result'] = "Fraud";
		}
	}
    if($eshopaction=='quantumwf_return'){
        switch($postit['trans_result']){
            case 'APPROVED':
				$status = "Completed";
				$postit['transID'] .= '| AuthCode: ' . $postid['authCode'];
                $echo .= "<div><p>Thank you for shopping with us. Your account has been charged and your transaction is successful. We will be shipping your order to you soon.</p></div>";
            break;
            case 'DECLINED':
				$status = "Failed";
                $echo .= '<div><p><font color="red">Transaction Declined. We\'re sorry, but the transaction has failed.</font></p></div>';
            break;
            default:
				$status = "Failed";
                $echo .= '<div><p><font color="red">Authorization Denied. We\'re sorry, but the transaction has failed.</font></p></div>';
            break;
        }
		
		$query2=$wpdb->query("UPDATE $detailstable set status='".$wpdb->escape($status)."',transid='".$wpdb->escape($postit['transID'])."' where checkid='".$wpdb->escape($postit['cust_id'])."'");
		$_SESSION = array();
		session_destroy();
    }
    return $echo;
}

?>